Subject: Re: linux-next: build failure after merge of the vfs tree

From: Stephen Rothwell <[email-masked]>
Date: Fri, 25 Sep 2020 22:01:28 +1000

Hi Al,

On Thu, 24 Sep 2020 21:08:07 +0100 Al Viro <[email-masked]> wrote:
>
> On Thu, Sep 24, 2020 at 06:30:38PM +1000, Stephen Rothwell wrote:
> > 
> > After merging the vfs tree, today's linux-next build (x86_64 allnoconfig)
> > failed like this:
> > 
> > arch/x86/include/asm/barrier.h: Assembler messages:
> > arch/x86/include/asm/barrier.h:41: Error: operand type mismatch for `cmp'
> > arch/x86/include/asm/barrier.h:41: Error: operand type mismatch for `cmp'
> > 
> > and many more ...
> > 
> > Caused by commit
> > 
> >   e33ea6e5ba6a ("x86/uaccess: Use pointer masking to limit uaccess speculation")
> > 
> > I am not exactly sure why (but reverting it fixes the build).
> > 
> > I have reverted that commit for today.  
> 
> Can't reproduce here...  This on top of today's -next seems to build with
> allnoconfig here:

I don't know what to tell you ... it still fails for me today.

$ x86_64-linux-gnu-gcc --version
x86_64-linux-gnu-gcc (Debian 10.2.0-9) 10.2.0
$ x86_64-linux-gnu-ld --version
GNU ld (GNU Binutils for Debian) 2.35

and the gcc plugins don't get built for the allnoconfig builds.

> diff --git a/lib/iov_iter.c b/lib/iov_iter.c
> index 35293ad83297..aca828b9b831 100644
> --- a/lib/iov_iter.c
> +++ b/lib/iov_iter.c
> @@ -647,7 +647,7 @@ static int copyout_mc(void __user *to, const void *from, size_t n)
>  {
>  	if (access_ok(to, n)) {
>  		instrument_copy_to_user(to, from, n);
> -		n = copy_mc_to_user((__force void *) to, from, n);
> +		n = copy_mc_to_user((__force void *)force_user_ptr(to), from, n);

BTW, You can't do that because force_user_ptr is only defined for x86 ...

I reverted my Revert commit after I finished linux-next today and built
the x86_64 allnoconfig verion of lib/iov_iter.s:

$ grep -A 1 '41 "/home/sfr/next/next/arch/x86/include/asm/barrier.h"' lib/iov_iter.s
# 41 "/home/sfr/next/next/arch/x86/include/asm/barrier.h" 1
	cmp $140737488351232,%rdx; sbb %rcx,%rcx;	#, uaddr, mask
--
# 41 "/home/sfr/next/next/arch/x86/include/asm/barrier.h" 1
	cmp $140737488351232,%r8; sbb %rdx,%rdx;	#, end, mask
--
# 41 "/home/sfr/next/next/arch/x86/include/asm/barrier.h" 1
	cmp $140737488351232,%rdx; sbb %rcx,%rcx;	#, uaddr, mask
--
# 41 "/home/sfr/next/next/arch/x86/include/asm/barrier.h" 1
	cmp $140737488351232,%rdi; sbb %rdx,%rdx;	#, end, mask
--
# 41 "/home/sfr/next/next/arch/x86/include/asm/barrier.h" 1
	cmp $140737488351232,%rdi; sbb %rax,%rax;	#, to.29_334, mask
--
# 41 "/home/sfr/next/next/arch/x86/include/asm/barrier.h" 1
	cmp $140737488351232,%rdi; sbb %rax,%rax;	#, to.29_367, mask
--
# 41 "/home/sfr/next/next/arch/x86/include/asm/barrier.h" 1
	cmp $140737488351232,%rsi; sbb %rax,%rax;	#, from.37_239, mask
--
# 41 "/home/sfr/next/next/arch/x86/include/asm/barrier.h" 1
	cmp $140737488351232,%rsi; sbb %rax,%rax;	#, from.37_272, mask
--
# 41 "/home/sfr/next/next/arch/x86/include/asm/barrier.h" 1
	cmp $140737488351232,%rsi; sbb %rax,%rax;	#, _i, mask
--
# 41 "/home/sfr/next/next/arch/x86/include/asm/barrier.h" 1
	cmp $140737488351232,%rsi; sbb %rax,%rax;	#, _i, mask
--
# 41 "/home/sfr/next/next/arch/x86/include/asm/barrier.h" 1
	cmp $140737488351232,%rsi; sbb %rax,%rax;	#, _i, mask
--
# 41 "/home/sfr/next/next/arch/x86/include/asm/barrier.h" 1
	cmp $140737488351232,%rsi; sbb %rax,%rax;	#, _i, mask
--
# 41 "/home/sfr/next/next/arch/x86/include/asm/barrier.h" 1
	cmp $140737488351232,%rdi; sbb %rax,%rax;	#, to.29_96, mask
--
# 41 "/home/sfr/next/next/arch/x86/include/asm/barrier.h" 1
	cmp $140737488351232,%rdi; sbb %rax,%rax;	#, to.29_244, mask
--
# 41 "/home/sfr/next/next/arch/x86/include/asm/barrier.h" 1
	cmp $140737488351232,%rsi; sbb %rax,%rax;	#, from.37_68, mask
--
# 41 "/home/sfr/next/next/arch/x86/include/asm/barrier.h" 1
	cmp $140737488351232,%rsi; sbb %rax,%rax;	#, from.37_221, mask
--
# 41 "/home/sfr/next/next/arch/x86/include/asm/barrier.h" 1
	cmp $140737488351232,%rsi; sbb %r10,%r10;	#, from.37_281, mask
--
# 41 "/home/sfr/next/next/arch/x86/include/asm/barrier.h" 1
	cmp $140737488351232,%rsi; sbb %rax,%rax;	#, from.37_314, mask
--
# 41 "/home/sfr/next/next/arch/x86/include/asm/barrier.h" 1
	cmp $140737488351232,%rsi; sbb %r10,%r10;	#, from.37_177, mask
--
# 41 "/home/sfr/next/next/arch/x86/include/asm/barrier.h" 1
	cmp $140737488351232,%rsi; sbb %rax,%rax;	#, from.37_210, mask
--
# 41 "/home/sfr/next/next/arch/x86/include/asm/barrier.h" 1
	cmp $140737488351232,%r10; sbb %rsi,%rsi;	#, _i, mask
--
# 41 "/home/sfr/next/next/arch/x86/include/asm/barrier.h" 1
	cmp $140737488351232,%rsi; sbb %rax,%rax;	#, _i, mask

I don't know if that helps.
-- 
Cheers,
Stephen Rothwell